﻿using System;
using System.Collections.Generic;
// using System.Linq;
using System.Text;
using System.Data.OracleClient;
using System.Data.Common;
using System.Data;

namespace AdoTestConsole
{
    class DataSetTest
    {
        public static void TestDataSet() {
            OracleDataAdapter da = new OracleDataAdapter("SELECT * FROM AUTHOR ORDER BY ID ASC", Resources.connectionString);
			
            OracleCommandBuilder cb = new OracleCommandBuilder(da);
            da.UpdateCommand = cb.GetUpdateCommand();
            da.InsertCommand = cb.GetInsertCommand();
            
            Console.WriteLine(da.UpdateCommand.CommandText);
            Console.WriteLine(da.InsertCommand.CommandText);

            DataTable dt = new DataTable("AUTHOR");
            da.Fill(dt);

            PrintDataTable(dt);
            
            foreach (DataRow row in dt.Rows){               
                if (((decimal)row["id"])==5)
                row["NAME"] = "Карл Маркс";                     
            }

            DataRow[] rows = dt.Select("id=5");
            
            DataRow newDataRow = dt.NewRow();
            newDataRow["ID"]   = 1111;
            newDataRow["NAME"] = "Алексей Толстой";
            newDataRow["BIRTHDATE"] = "21.11.2008";
            dt.Rows.Add(newDataRow);

			dt.WriteXml(@"c:\data.xml", XmlWriteMode.DiffGram);

            da.Update(dt);

            DataTable dt2 = new DataTable();
            da.Fill(dt2);

            PrintDataTable(dt);
        }
    

        public static void PrintDataTable(DataTable dt)
        {
            Console.WriteLine("ID\t\tNAME\t\tBIRTHDAY DATE");
            Console.WriteLine("=====================================================");
            foreach (DataRow item in dt.Rows)
            {
                Console.WriteLine(String.Format("{0}\t\t{1}\t\t{2}", item["id"], item["name"], item["BirthDate"]));
            }
            Console.WriteLine("=====================================================");
            Console.WriteLine("Total {0} rows selected", dt.Rows.Count);
            Console.WriteLine("=====================================================");
            
        }
       
    }
}
