using System;
using System.Collections.Generic;
// using System.Linq;
using System.Text;

namespace AdoTestConsole
{
    class Program
    {
        static void PrepareDB()
        {
            AuthorsGateway gateway = new AuthorsGateway();
            gateway.removeAllAuthors();       
            for (int i = 0; i < 10; ++i)
            {
                gateway.AddNewAuthor(i, Resources.authors[i], DateTime.Now);
            }
              
        }

        static void PrintAuhtorList(List<Author> list)
        {
            Console.WriteLine("ID\t\tNAME\t\tBIRTHDAY DATE");
            Console.WriteLine("=====================================================");
            foreach (Author item in list)
            {
                Console.WriteLine(String.Format("{0}\t\t{1}\t\t{2}", item.Id, item.Name, item.BirthDate.ToShortDateString()));
            }
            Console.WriteLine("=====================================================");
            Console.WriteLine("Total {0} rows selected", list.Count);
            Console.WriteLine("=====================================================");
            
        }

        public static void TestActiveRecord()
        {
            PrintAuhtorList(Author.Find(""));
            Author virt = new Author();
            virt.Id = 1999;
            virt.Name = "Вирт";
            virt.Save();
            PrintAuhtorList(Author.Find("Вирт"));
            virt.Delete();
            PrintAuhtorList(Author.Find("Вирт"));
        }


        public static void TestADO()
        {
            AuthorsGateway gateway = new AuthorsGateway();
            gateway.AddNewAuthor(66, "Вася Пупкин", DateTime.Now);
            gateway.UpdateAuthor(1, "Бьярн Страуструп", DateTime.Now);
            gateway.removeAuthor(2);
            gateway.ListAuthors();
        }

        public static void TestTransaction()
        {
            AuthorsGateway gateway = new AuthorsGateway();
            gateway.ListAuthors();
            gateway.TransactionTest();
            gateway.ListAuthors();
        }

        public static void TestSP()
        {
            AuthorsGateway gateway = new AuthorsGateway();
            gateway.removeAllAuthors();
            int id = gateway.AddNewAuthorViaSP("Hank", DateTime.Now);
            gateway.ListAuthors();
            Console.WriteLine("Inserted ID = {0}", id);
        }

        static void Main(string[] args)
        {
            PrepareDB();
            //TestADO();
            //TestTransaction();
            //TestSP();
            // TestActiveRecord();
            DataSetTest.TestDataSet();            
            Console.ReadLine();
        }
    }
}
