
CREATE TABLE AUTHOR (
       ID                   INTEGER NOT NULL,
       NAME                 VARCHAR2(200) NOT NULL,
       BIRTHDATE            DATE NULL
);


ALTER TABLE AUTHOR
       ADD  ( PRIMARY KEY (ID) ) ;


CREATE TABLE CATALOG (
       ID                   INTEGER NOT NULL,
       NAME                 VARCHAR2(100) NOT NULL
);


ALTER TABLE CATALOG
       ADD  ( PRIMARY KEY (ID) ) ;


CREATE TABLE CATALOG_ITEM (
       ID                   INTEGER NOT NULL,
       CATALOG_ID           INTEGER NOT NULL,
       AUTHOR_ID            INTEGER NOT NULL,
       NAME                 VARCHAR2(200) NOT NULL,
       ISBN                 VARCHAR2(13) NULL,
       GENRE                VARCHAR2(10) NULL,
       ITEM_TYPE            VARCHAR2(10) NOT NULL
);

CREATE INDEX XIF1CATALOG_ITEM ON CATALOG_ITEM
(
       CATALOG_ID                     ASC
);

CREATE INDEX XIF2CATALOG_ITEM ON CATALOG_ITEM
(
       AUTHOR_ID                      ASC
);


ALTER TABLE CATALOG_ITEM
       ADD  ( PRIMARY KEY (ID) ) ;


ALTER TABLE CATALOG_ITEM
       ADD  ( FOREIGN KEY (AUTHOR_ID)
                             REFERENCES AUTHOR ) ;


ALTER TABLE CATALOG_ITEM
       ADD  ( FOREIGN KEY (CATALOG_ID)
                             REFERENCES CATALOG ) ;


CREATE SEQUENCE ID_SEQ;

CREATE OR REPLACE PROCEDURE ADD_AUTHOR(p_NAME IN VARCHAR2, p_BIRTHDATE IN DATE, p_ID OUT INTEGER) AS
BEGIN
   SELECT ID_SEQ.NEXTVAL INTO p_ID FROM DUAL;
   INSERT INTO AUTHOR(ID, NAME, BIRTHDATE) VALUES (p_ID, p_NAME, p_BIRTHDATE);
END;
/